Strict

AppTitle="Weihnachtsbaum schmuecken - v0.1 - Michael Homeister"
Graphics 800,600,0,60
SetBlend ALPHABLEND
SetMaskColor 255,0,255

Const GESCHENK1:Int=1
Const GESCHENK2:Int=2
Const KUGELN_BLAU:Int=4
Const KUGELN_GELB:Int=8
Const KUGELN_GRUEN:Int=16
Const KUGELN_ROT:Int=32
Const SCHLEIFEN:Int=64
Const STERN:Int=128
Const ZUCKER:Int=256
Const ZWEIG:Int=512
Const GLOCKEN:Int=1024

Include "TModellBaum.bmx"

Global img_bg:TImage=LoadImage("gfx/bg.png")
Global img_weihnachtsmann:TImage=LoadImage("gfx/weihnachtsmann1.png")
Global img_icon:TImage[20]
img_icon[0]=LoadImage("gfx/icon_geschenk1.png")
img_icon[1]=LoadImage("gfx/icon_geschenk2.png")
img_icon[2]=LoadImage("gfx/icon_blau.png")
img_icon[3]=LoadImage("gfx/icon_gelb.png")
img_icon[4]=LoadImage("gfx/icon_gruen.png")
img_icon[5]=LoadImage("gfx/icon_rot.png")
img_icon[6]=LoadImage("gfx/icon_schleifen.png")
img_icon[7]=LoadImage("gfx/icon_stern.png")
img_icon[8]=LoadImage("gfx/icon_zucker.png")
img_icon[9]=LoadImage("gfx/icon_zweig.png")
img_icon[10]=LoadImage("gfx/icon_glocken.png")
Global mhit1:Int

TBaum.Init

Global mybaum:TMyBaum=New TMyBaum
mybaum.SetPos(250,200)

Global baum:TModellBaum=TModellBaum.CreateRandom()


Repeat
	Cls
		'###################### CALC ############################
		mhit1=MouseHit(1)
		
		'###################### DRAW ############################
		SetColor 255,255,255
		DrawImage img_bg,0,0
		
		DrawStrangeSanta
		
		baum.draw
		mybaum.draw
		
		mybaum.setup(mhit1)
		mybaum.compete(baum)
		'DrawText mybaum.anhang,5,5
		
		'Maus		
		DrawOval MouseX()-1, MouseY()-1,2,2
		SetColor 255,255,255
		
	Flip
Until KeyHit(KEY_ESCAPE)

Function DrawStrangeSanta()
	SetScale .5,.5
	DrawImage img_weihnachtsmann,587,387
	SetScale 1,1
	
	Local angle1:Int=ATan2(MouseY()-(387+56), MouseX()-(587+113))
	Local angle2:Int=ATan2(MouseY()-(387+56), MouseX()-(587+128))
	
	SetColor 0,0,0
	DrawOval (587+113)+Cos(angle1)*5 -2, (387+56)+Sin(angle1)*10 -2, 4,4
	DrawOval (587+128)+Cos(angle2)*5 -2, (387+56)+Sin(angle2)*10 -2, 4,4
	SetColor 255,255,255
	
End Function

Function RectsOverlap(x0, y0, w0, h0, x2, y2, w2, h2)
	If x0 > (x2 + w2) Or (x0 + w0) < x2 Then Return False
	If y0 > (y2 + h2) Or (y0 + h0) < y2 Then Return False
	Return True
End Function