Global resX = 1024, resY = 768

Graphics3D resX,resY,32,2
SetBuffer BackBuffer()
AppTitle "BCC45"
Local Timer = CreateTimer(60)

Global cam = CreateCamera()
PositionEntity cam, 0, 25, -25
Local CamPointer = CreatePivot()
PositionEntity CamPointer, 0, 0, -7
PointEntity cam, CamPointer
SeedRnd(MilliSecs())

Global SetMesh, BlockSetMesh, Picked

Local boden0 = CreatePlane()
EntityColor boden0, 255, 250, 250
Local boden = CreateCube()
Local boden_tex = LoadTexture("media\boden001.jpg")
EntityTexture boden, boden_tex
ScaleEntity boden, 50, .1, 50
EntityPickMode boden, 2
PositionEntity boden, 0, 0, 20

Global spielstatus = 1
Dim score(3) 			; 1: Geschenke am Beginn, 2: Geschenke neu, 3: Abschsse
Dim time#(4) 			; 1: Zeit zu beginn(9:00), 2: Zeit am Ende (11:00), 3: Spielzeit Gesamt in min, 4: PauseOldTime
score(1) = 10
score(2) = score(1)
time(1) = MilliSecs()	; wird in der Endformel auf 9:00 gerechnet
time(2) = 7200000 		; 2h von 9 - 11 in Millisecs
time(3) = 2				; 2 Minuten Spielzeit
Global wichtelSpeed# = .1

Global staticObjectPage = 0 ; 1...9 = eine Page
Dim staticObject(10)
staticObject(0) = LoadMesh("media\baum001.b3d")				: EntityPickMode staticObject(0), 2: HideEntity staticObject(0): EntityType staticObject(0), 4
staticObject(1) = LoadAnimMesh("media\deer001.b3d")			: EntityPickMode staticObject(1), 2: HideEntity staticObject(1)
staticObject(2)	= LoadMesh("media\haus001.b3d")				: EntityPickMode staticObject(2), 2: HideEntity staticObject(2): EntityType staticObject(2), 4
staticObject(3) = LoadMesh("media\present001.b3d")			: EntityPickMode staticObject(3), 2: HideEntity staticObject(3)
staticObject(4)	= LoadMesh("media\present002.b3d")			: EntityPickMode staticObject(4), 2: HideEntity staticObject(4)
staticObject(5)	= LoadMesh("media\wagon.b3d")				: EntityPickMode staticObject(5), 2: HideEntity staticObject(5)
staticObject(6) = LoadAnimMesh("media\npc_w001.b3d")		: EntityPickMode staticObject(6), 2: HideEntity staticObject(6)
staticObject(7)	= LoadAnimMesh("media\npc_wm001.b3d")		: EntityPickMode staticObject(7), 2: HideEntity staticObject(7)
staticObject(8)	= LoadAnimMesh("media\schneemann001.b3d")	: EntityPickMode staticObject(8), 2: HideEntity staticObject(8): EntityType staticObject(8), 4

Local baum_tex 		= LoadTexture("media\tree2.jpg")
Local deer_tex 		= LoadTexture("media\deer2.jpg")
Local haus_tex 		= LoadTexture("media\haus2.jpg")
Local wagon_tex 	= LoadTexture("media\wagon2.jpg")
Local wm_tex 		= LoadTexture("media\npc_wm.jpg")
Local sm_tex 		= LoadTexture("media\schneemann2.jpg")

Dim wichtel_textures(3)
wichtel_textures(1) = LoadTexture("media\npc_w1.jpg")
wichtel_textures(2) = LoadTexture("media\npc_w2.jpg")
wichtel_textures(3) = LoadTexture("media\npc_w3.jpg")

Dim present1_textures(4)
present1_textures(1) = LoadTexture("media\present12.jpg")
present1_textures(2) = LoadTexture("media\present13.jpg")
present1_textures(3) = LoadTexture("media\present14.jpg")
present1_textures(4) = LoadTexture("media\present15.jpg")

Dim present2_textures(4)
present2_textures(1) = LoadTexture("media\present22.jpg")
present2_textures(2) = LoadTexture("media\present23.jpg")
present2_textures(3) = LoadTexture("media\present24.jpg")
present2_textures(4) = LoadTexture("media\present25.jpg")

EntityTexture staticObject(0), baum_tex
EntityTexture staticObject(1), deer_tex
EntityTexture staticObject(2), haus_tex
EntityTexture staticObject(5), wagon_tex
EntityTexture staticObject(7), wm_tex
EntityTexture staticObject(8), sm_tex

Global PicPunkte 	= LoadImage("media\punkte.png")
Global PicPunkte2 	= LoadImage("media\punkte2.png")
Global PicPresent 	= LoadImage("media\present.png")
Global PicWichtel 	= LoadImage("media\PicWichtel.png")
Global PicIntro 	= LoadImage("media\Intro.jpg"): ResizeImage PicIntro, resX, resY
Global PicFlocke 	= LoadSprite2("media\schneeflocke.png",4): EntityBlend PicFlocke, 3 :HideEntity PicFlocke ; Custom Sprite Funktion, da normale Sprites idR. MAV's geben
Global PicPause 	= LoadImage("media\pause.png")

; Lichter
AmbientLight 150,150,200 ; - Fading zu N8 wird verrechnet in updateTime
sternenlicht = CreateLight(3): PositionEntity sternenlicht, 0,20,-30: LightRange sternenlicht, 70: LightColor sternenlicht, 240, 240, 100
scenenlicht = CreateLight(3): PositionEntity scenenlicht, 20,20,-20: LightRange scenenlicht, 100: LightColor scenenlicht, 100, 100, 250
ptr = CreatePivot(): PositionEntity ptr, 10,0,-10: PointEntity scenenlicht, ptr

staticObject(9) = CopyEntity(staticObject(0)) ; Weihnachtsbaum
temp = LoadMesh("media\prhaufen.b3d", staticObject(9))	; Vortexturiert
temp = LoadMesh("media\stern.b3d", staticObject(9)): PositionEntity temp, 0, 10.24, 0
	EntityColor temp, 245, 240, 100: EntityShininess temp, .5: : HideEntity staticObject(9)
	
ExtractAnimSeq(staticObject(1),4,31) 	; deer luft
ExtractAnimSeq(staticObject(6),4,31) 	; wichtel luft
ExtractAnimSeq(staticObject(6),32,61) 	; wichtel hebt geschenk auf
ExtractAnimSeq(staticObject(6),63,91) 	; wichtel luft mit geschenk
ExtractAnimSeq(staticObject(6),122,151) ; wichtel wurde getroffen
ExtractAnimSeq(staticObject(6),92,121)  ; wichtel wurde geschlagen
ExtractAnimSeq(staticObject(7),4,31) 	; weihnachtsmann feuert mit schneeball
ExtractAnimSeq(staticObject(8),4,31) 	; schneemann winkt

Global weihnachtsbaum 					; Achtung der letzt gesetzte WeihnachtsBaum ist der weihnachtsbaum

Global Sledge = CreatePivot() 			; Center pivot / am Baum
PositionEntity Sledge, 0, 0, 5
Local SledgeMD = CreatePivot(Sledge) 	; Alle Objekte die zum Schlitten gehren
Local d1 = CopyEntity(staticObject(1),SledgeMD): 	PositionEntity d1, -0.8, 1.25, 2.55	: Animate d1, 2, 1, 1 ; Tier mit Geweih und roter Nase 1
Local d2 = CopyEntity(staticObject(1),SledgeMD): 	PositionEntity d2, +0.8, 1.25, 2.55	: Animate d2, 2, 1, 1 ; Tier mit Geweih und roter Nase 2
Local smd = CopyEntity(staticObject(5),SledgeMD): 	PositionEntity smd, 0, 0, -3	; Schlittenmodell

Local noselight
noselight = CreateLight(2,d1): PositionEntity noselight, 0,1,5: LightRange noselight, 8: LightColor noselight, 250, 0, 0
noselight = CreateLight(2,d2): PositionEntity noselight, 0,1,5: LightRange noselight, 8: LightColor noselight, 250, 0, 0

Dim smdColl(3) ; Schlitten Modell Collision
smdColl(1) = CreatePivot(smd):PositionEntity smdColl(1), 0, 1, -3.3 : EntityType smdColl(1), 3: EntityRadius smdColl(1), 2 ;schlitten hinten collision
smdColl(2) = CreatePivot(smd):PositionEntity smdColl(2), 0, 1, -.5	: EntityType smdColl(2), 3: EntityRadius smdColl(2), 2 ;schlitten vorn collision
smdColl(3) = CreatePivot(smd):PositionEntity smdColl(3), 0, 1, 6.5	: EntityType smdColl(3), 3: EntityRadius smdColl(3), 2 ;deer collision

Global wm = CopyEntity(staticObject(7),SledgeMD): 	PositionEntity wm, 0, 0.7, -4.56
PositionEntity SledgeMD, 10, 0, 0 		; schaffe Umlaufbahn

;Sounds
Dim sounds(2) 
;Sounds von:     http://www.tote-taste.de/Einsatzleitung/Service/Wavs/WavSystemSounds.html
sounds(1) = LoadSound("sounds\WAV158.WAV"): SoundVolume sounds(1), .3
sounds(2) = LoadSound("sounds\WAV030.WAV"): SoundVolume sounds(2), .05 ; raus da doch etwas nervig

Global mouse1hit 		; Eingaben
Dim currwaypoints(2) 	; run, waypoint
Global spawntimer = 0, memtimer = MilliSecs()	; jede XX Sekunde ein Wichtel

; Fonts
Global font1 = LoadFont("Courier",15)
Global font2 = LoadFont("Courier",10)
Global font3 = LoadFont("Courier",30,1)
SetFont font2

; Wichtel Stati
Const die = 4, slap = 5

Collisions 2, 1, 2, 1 ; Ball collidiert mit Wichtel
Collisions 3, 1, 2, 1 ; Schlitten collidiert mit Wichtel
Collisions 2, 4, 2, 1 ; Ball collidiert mit Objekten ( Baum, Haus, Schneemann )

Type TstaticMesh
	Field x
	Field z
	Field yaw
	Field objNum
	Field mesh
End Type

Type TBullet
	Field s#[3]
	Field t#[3]
	Field speed#
	Field mesh
	Field art ; bullet = 1, wichtel = 2, geschenk = 3
End Type

Type Twaypoint
	Field wpn ; wp innerhalb des runnes
	Field wpr ; run
	Field x#
	Field z#
	Field mesh
End Type

Type Twichtel
	Field mesh
	Field targetmesh ; ein waypoint
	Field status ; fr oneshot animations ( 1 hinlaufen - 2 aufheben - 3 zurcklaufen - 4 getroffen)
	Field geschenkmesh
End Type

Type Tschnee ; Schneeflocken
	Field mesh
End Type

Repeat
	
	mouse1hit = MouseHit(1)
	
	; 3D
	Select spielstatus 
		Case 1: ;Start
			If mouse1hit = 1 Then 
				Local nextStatus = 0
				Local sx1# = (Float(210)/1024*resX) ; Auflsungsabhngigkeit
				Local sx2# = (Float(410)/1024*resX)
				Local sx3# = (Float(600)/1024*resX)
				Local sdx# = (Float(170)/1024*resX)
				Local sy#  = (Float(560)/768*resY)
				Local sdy# = (Float(60)/768*resY)
				
				If MouseX() > sx1 And MouseX() < sx1 + sdx# And MouseY() > sy# And MouseY() < sy# + sdy# ;easy
					spawntimer = 1000
					nextStatus = 1
				EndIf
				If MouseX() > sx2 And MouseX() < sx2 + sdx# And MouseY() > sy# And MouseY() < sy# + sdy# ;normal
					spawntimer = 650
					nextStatus = 1
				EndIf
				If MouseX() > sx3 And MouseX() < sx3 + sdx# And MouseY() > sy# And MouseY() < sy# + sdy# ;hard
					spawntimer = 400
					nextStatus = 1
				EndIf
				
				If nextStatus = 1 Then 
					spielstatus = 2
					time(1) = MilliSecs()	; 1: Zeit zu beginn(9:00), 2: Zeit am Ende (11:00), 3: Spielzeit Gesamt in min, 4: PauseOldTime
					memtimer = MilliSecs()	; Timer welche sich die Zeit des letzten Spawns merkt
					gameINIT()
					newSchnee(60) ; Gib mir n Schneeflocken
				EndIf
			EndIf
		Case 2: ; Spiel
			If KeyHit(57) Then ; leertaste: Pause/ keine Pause
				updateTime$(1)
			EndIf
			
			If time(4) = 0 Then ; keine Pause gedrckt
				For staticMesh.TstaticMesh = Each TstaticMesh
					EntityPickMode staticMesh\mesh, 0
				Next
				
				Picked = CameraPick( cam, MouseX(), MouseY() )
				
				For staticMesh.TstaticMesh = Each TstaticMesh
					EntityPickMode staticMesh\mesh, 2
				Next
				
				AlignToVector wm, PickedX()-EntityX(wm,1), 0, PickedZ()-EntityZ(wm,1), 3 ; Weihnachtsmann drehung
				
				player()
				
				updateSledge()
				updateBullet()
				updateWichtel()
				updateSchnee()
			EndIf
		Case 3: ;Ende
			For wichtel.Twichtel = Each Twichtel
				If wichtel\geschenkmesh > 0 Then newBullet(EntityX(wichtel\geschenkmesh), EntityY(wichtel\geschenkmesh), EntityZ(wichtel\geschenkmesh), EntityX(weihnachtsbaum), EntityY(weihnachtsbaum), EntityZ(weihnachtsbaum), wichtel\geschenkmesh, 3)
				deleteWichtel(wichtel\mesh)
				Animate d1, 0, 1, 1
				Animate d2, 0, 1, 1
			Next
			updateBullet()
	End Select
	
	UpdateWorld()
	RenderWorld()
	
	;2D
	Select spielstatus 
		Case 1: ;Start
			DrawImage PicIntro, 0, 0 
			;Rect (Float(210)/1024*resX), (Float(560)/768*resY), (Float(170)/1024*resX), (Float(60)/768*resY), 1
			;Rect (Float(410)/1024*resX), (Float(560)/768*resY), (Float(170)/1024*resX), (Float(60)/768*resY), 1
			;Rect (Float(600)/1024*resX), (Float(560)/768*resY), (Float(170)/1024*resX), (Float(60)/768*resY), 1
		Case 2: ; Spiel
			If time(4) > 0 Then ; Pause gedrckt
				Msg2D(1)
			EndIf
			
			DrawImage PicPresent, 10, 50
			SetFont font3
			Text 75,70, score(2) ; Geschenke
			DrawImage PicWichtel, 10, 110
			
			Text 75,130, score(3) ; Abschsse
			Text 10,10, updateTime$() ; 1 = pause, 2 = weiter
			
			;SetFont font2
			;Text 10, 200, "SetMesh: " + SetMesh + " BlockSetMesh: " + BlockSetMesh ; Editor funktion ist in dem QC nicht enthalten, da nicht bentigt
		Case 3: ;Ende
			Msg2D(2)
			SetFont font2
			
			sw = StringWidth("Developed            for BCC45 - http://www.blitzforum.de/forum")
			sx = resX - sw - 5
			sy = resY - 40 - 5
			
			Text sx, sy + 0*10, "Credits:"
			Text sx, sy + 1*10, "Coding & 3D-Modells  by V.B. (Hakkai)"
			Text sx, sy + 2*10, "Sounds               by www.tote-taste.de"
			Text sx, sy + 3*10, "Developed            for BCC45 - http://www.blitzforum.de/forum"
	End Select
	
	mouse1hit = 0
	
	WaitTimer(Timer)
	Flip(0)
	
Until KeyHit(1)
cleanUp()
End

;--------------------

Function restartGame()
	
	cleanUp(True) 			; restartflag gesetzt
	score(2) = score(1)		; Geschenke neu
	score(3) = 0			; 1: Geschenke am Beginn, 2: Geschenke neu, 3: Abschsse
	RotateEntity Sledge, 0, 0, 0
	spielstatus = 1
	
End Function

;--------------------

Function updateSchnee()
	For schnee.Tschnee = Each Tschnee
		spx# = EntityX(schnee\mesh)
		spy# = EntityY(schnee\mesh) - .05
		spz# = EntityZ(schnee\mesh)
		
		If spy# <= 0 Then spy# = Rnd(20,40): spx# = Rnd(-30,30): spz# = Rnd(-30,30)
		
		rot# = EntityRoll(schnee\mesh) + .5
		If rot# > 360 Then rot# = 0
		PositionEntity schnee\mesh, spx#, spy#, spz#
		PointEntity schnee\mesh, cam, rot#
	Next
End Function

;--------------------

Function newSchnee(n)
	For i = 1 To n
		schnee.Tschnee = New Tschnee
		schnee\mesh = CopyEntity(PicFlocke)
		PositionEntity schnee\mesh, Rnd(-30,30), Rnd(20,50), Rnd(-30, 30)
		PointEntity schnee\mesh, cam, Rnd(360)
		ScaleEntity schnee\mesh, .4, .4, 1
	Next
End Function

;--------------------

Function cleanUp(restartflag = 0)
	;Meshes + Type.Objects
	For staticMesh.TstaticMesh = Each TstaticMesh
		FreeEntity staticMesh\mesh
		Delete staticMesh
	Next
	For Bullet.TBullet = Each TBullet
		If Bullet\art <> 2 Then FreeEntity Bullet\mesh ; Wichtel (art=2) wird anschlieend gelscht
		Delete Bullet
	Next
	For waypoint.Twaypoint = Each Twaypoint
		FreeEntity waypoint\mesh
		Delete waypoint
	Next
	For wichtel.Twichtel = Each Twichtel
		FreeEntity wichtel\mesh
		Delete wichtel
	Next
	For schnee.Tschnee = Each Tschnee
		FreeEntity schnee\mesh
		Delete schnee
	Next
	
	If restartflag = True Then Return 0
	
	FreeEntity boden
	For i=0 To 9
		FreeEntity staticObject(i)
	Next
	
	;Images
	FreeImage PicPunkte
	FreeImage PicPresent
	FreeImage PicWichtel
	
	FreeImage PicPunkte2
	FreeImage PicIntro
	FreeImage PicFlocke
	
	;Sounds
	FreeSound sounds(1)
	FreeSound sounds(2)
	
	;Fonts
	FreeFont font1
	FreeFont font2
	FreeFont font3
	
	;Textures
	FreeTexture baum_tex
	FreeTexture deer_tex
	FreeTexture haus_tex
	FreeTexture wagon_tex
	FreeTexture wm_tex
	FreeTexture sm_tex
	For i = 1 To 3
		FreeTexture wichtel_textures(i)
	Next
	For i = 1 To 4
		FreeTexture present1_textures(i)
		FreeTexture present2_textures(i)
	Next
End Function

;--------------------

Function Msg2D(status)
	; score(3): Abschuss 10 Punkte, Geschenke Bonus: 50 pro Geschenk
	; Dim score(3) 		; 1: Geschenke am Beginn, 2: Geschenke neu, 3: Abschsse
	Local PICw, PICh, drawAtY, drawAtX
	
	Select status
		Case 1: ; Pause
			PICw = 130
			PICh = 70
			
			drawAtY = resY/2 - PICh/2
			drawAtX = resX/2 - PICw/2
			
			DrawImage PicPause, drawAtX, drawAtY
		Default: ; 2: Spielende
			PICw = 512
			PICh = 300
			
			drawAtY = resY/2 - PICh/2
			drawAtX = resX/2 - PICw/2
			
			If score(2) > 0 Then
				DrawImage PicPunkte, drawAtX, drawAtY
			Else
				DrawImage PicPunkte2, drawAtX, drawAtY
			EndIf
			;Rect drawAtX+200, drawAtY+200, 270, 55, 1
			
			If MilliSecs() > time(1) + 2000 	; Klickschutz fr 2 Sek
				If MouseX() > (drawAtX+200) And MouseX() < (drawAtX+200+270) And MouseY() > (drawAtY+200) And MouseY() < (drawAtY+200+55) And mouse1hit = 1 Then restartGame()
				;Text (drawAtX+200+140), (drawAtY+200+57), "Restart unlocked"
			Else
				Text (drawAtX+200+140), (drawAtY+200+57), "Restart locked"
			EndIf
			
			
			SetFont font1
			Text drawAtX + 90, drawAtY + 130, "      Abschuesse: " + score(3) + " * 10 Punkte: " + (score(3)*10)
			Text drawAtX + 90, drawAtY + 150, "Geschenke uebrig: " + score(2) + " * 50 Punkte: " + (score(2)*50)
			Text drawAtX + 90, drawAtY + 170, "          Gesamt: " + (score(3)*10 + score(2)*50)
	End Select
End Function

;--------------------

Function updateTime$(status = 0)
	Local timeNew
	If time#(4) > 0 Then ; Pause gerade aktiv
		If status = 1 ; Leertaste gedrckt -> da pause aktiv war wird sie nun inaktiv (Spiel wird fortgesetzt)
			time(1) = time(1) + ( MilliSecs() - time(4) )
			time#(4) = 0
			timeNew = MilliSecs()
		Else
			timeNew = time#(4)
		EndIf
	Else ; normaler Spielfluss
		If status = 1 ; Leertaste gedrckt -> da das Spiel lief wird jetzt Pausiert
			time#(4) = MilliSecs()
			timeNew = time#(4)
		Else
			timeNew = MilliSecs()
		EndIf
	EndIf
	
	; Die Fiktiven zu berbrckenden 2 Stunden auf die reelle Gesamtspielzeit time(3) Projezieren
	Local rTimeGes = time(3) * 60 * 1000			; Spieldauer reell in Millisecs
	Local vfrTime# = time(2) / Float(rTimeGes) 		; Verhltnis Fikitv Real Zeiteinheit
	Local drTime = timeNew - time(1) 				; vergangene reelle Spielzeit im Millisecs
	Local fTimeNow# = drTime * vfrTime#
	If fTimeNow# > 7200000 Then
		time(1) = MilliSecs()						; variable wird hier missbraucht um 2 sec Klickschutz frs Restartgame einzufgen
		spielstatus = 3
		Return 0	; 2 fiktive Stunden sind vergangen
	EndIf
	
	; Rckgabe Zeit String zusammenbasteln
	Local timeInMS = 32400000+fTimeNow#
	Local h = timeInMS/(1000*60*60)
	Local m_inMS = timeInMS Mod (1000*60*60)
	Local m = m_inMS / (1000*60)
	
	Local mst$ = "" + m
	If m < 10 Then mst$ = "0" + m
	
	Local timeString$ = "" + h + ":" + mst$ + " PM"
	
	; Die Fiktiven zu berbrckenden 2 Stunden auf die LightDec Projezieren
	Local LightDec# = 100
	Local Nightlight# = LightDec/rTimeGes*drTime
	
	;DebugLog Nightlight
	AmbientLight 150-Nightlight,150-Nightlight,200-Nightlight
	
	Return timeString$
End Function

;--------------------

Function updateSledge()
	TurnEntity Sledge, 0, .5, 0
	piv = CreatePivot()
	For i = 1 To 3
		cc = CountCollisions(smdColl(i))
		If cc > 0 Then 
			collmesh = EntityCollided(smdColl(i),1)
			PositionEntity piv, CollisionX(smdColl(i),cc), CollisionY(smdColl(i),cc), CollisionZ(smdColl(i),cc)
			If collmesh > 0 And weihnachtsbaum > 0 Then
				If EntityDistance(weihnachtsbaum, piv) < EntityDistance(weihnachtsbaum, collmesh) Then ; Bewegung weg vom Baum
					PointEntity piv, collmesh: MoveEntity piv, 0,0,5
				Else ; Bewegung zum Baum
					PointEntity piv, weihnachtsbaum: MoveEntity piv, 0,0,5
				EndIf
				updateWichtel(collmesh,slap,piv)
			EndIf
		EndIf
	Next
	FreeEntity piv
End Function

;--------------------

Function player()
	If mouse1hit = 1 Then
		Animate wm, 3, 5, 1
		newBullet(EntityX#(wm,1),EntityY#(wm,1),EntityZ#(wm,1),PickedX(),PickedY(),PickedZ())
	EndIf
End Function

;--------------------

Function newWichtel(spawnWPR)
	wichtel.Twichtel = New Twichtel
	wichtel\mesh = CopyEntity(staticObject(6)): EntityType wichtel\mesh, 1: Animate wichtel\mesh, 2, 1, 1 ; Laufanimation PINGPONG
	EntityTexture wichtel\mesh, wichtel_textures(Rnd(1,3))
	For waypoint.Twaypoint = Each Twaypoint
		If waypoint\wpr = spawnWPR Then Exit
	Next
	waypoint = After waypoint
	If waypoint = Null Then waypoint.Twaypoint = Last Twaypoint
	wichtel\targetmesh = waypoint\mesh
	wichtel\status = 1
	Return wichtel\mesh
End Function

;--------------------

Function updateWichtel(mesh=0,status=0,slappiv=0)
	Local temp
	For wichtel.Twichtel = Each Twichtel
		If wichtel\mesh = mesh And status = slap And wichtel\status <> slap Then
			Animate wichtel\mesh, 3, 2, 5; getroffen
			EntityType wichtel\mesh, 0 ; Collision im Slap verwerfen
			wichtel\status = slap
			newBullet(EntityX(wichtel\mesh), EntityY(wichtel\mesh), EntityZ(wichtel\mesh), EntityX(slappiv), EntityY(slappiv), EntityZ(slappiv), wichtel\mesh, 2)
		EndIf
		If mesh = wichtel\mesh And status = die Then ; treffer und versenkt
			Animate wichtel\mesh, 3, 3, 4; getroffen
			wichtel\status = die
			EntityType wichtel\mesh, 0 ; Collision im wichtelFall verwerfen
			newSound("hit")
			score(3) = score(3) + 1
			skip = 1
		EndIf
		If wichtel\status = slap ; schlag = 5
			If Animating (wichtel\mesh) = False Then 
				If wichtel\geschenkmesh > 0 Then
					wichtel\status = 3 ; lauf mit Geschenk
					Animate wichtel\mesh, 2, 1, 3; lauf mit Geschenk animation PINGPONG
				Else
					wichtel\status = 1 ; lauf
					Animate wichtel\mesh, 2, 1, 1; lauf animation PINGPONG
				EndIf
				EntityType wichtel\mesh, 1 ; Collision wieder aktivieren
			EndIf
			skip = 1
		EndIf
		If wichtel\status = die ; getroffen = 4
			If Animating (wichtel\mesh) = False Then 
				If wichtel\geschenkmesh > 0 Then newBullet(EntityX(wichtel\geschenkmesh), EntityY(wichtel\geschenkmesh), EntityZ(wichtel\geschenkmesh), EntityX(weihnachtsbaum), EntityY(weihnachtsbaum), EntityZ(weihnachtsbaum), wichtel\geschenkmesh, 3)
				deleteWichtel(wichtel\mesh)
			EndIf
			skip = 1
		EndIf
		If skip = 0 And weihnachtsbaum <> 0 Then 
			If EntityDistance (wichtel\mesh,weihnachtsbaum) < 3 Then
				If wichtel\status = 2 Then ; Check ob animation vorbei ist
					If Animating (wichtel\mesh) = False Then 
						wichtel\status = 3
						rnd2 = Rnd(3,4)
						wichtel\geschenkmesh = CopyEntity(staticObject(rnd2), wichtel\mesh)
						If rnd2 = 3 Then EntityTexture wichtel\geschenkmesh, present1_textures(Rnd(1,4))
						If rnd2 = 4 Then EntityTexture wichtel\geschenkmesh, present2_textures(Rnd(1,4)): RotateEntity wichtel\geschenkmesh, 0, 90, 0
						PositionEntity wichtel\geschenkmesh, 0, 1.5, 1
						Animate wichtel\mesh, 2, 1, 3; lauf mit geschenk animation PINGPONG
					EndIf
					skip = 1 ; nicht weiterlaufen bis animation fertig
				ElseIf wichtel\status = 1
					wichtel\status = 2 ; heb geschenk auf
					Animate wichtel\mesh, 3, 1, 2 ; aufheb animation ONCE
					skip = 1
				EndIf
			EndIf
		EndIf
		If skip = 0 Then
			If EntityDistance (wichtel\mesh, wichtel\targetmesh) < 1 Then ; nchsten Waypoint als Ziel auswhlen
				For waypoint.Twaypoint = Each Twaypoint
					If waypoint\mesh = wichtel\targetmesh Then
						old_wpr = waypoint\wpr
						waypoint = After waypoint
						
						If waypoint = Null Then 
							If wichtel\geschenkmesh <> 0 Then score(2) = score(2) - 1
							If score(2) <=0 Then spielstatus = 3
							FreeEntity wichtel\geschenkmesh: wichtel\geschenkmesh = 0: deleteWichtel(wichtel\mesh) ; delete
							Exit
						EndIf
						If old_wpr <> waypoint\wpr Then 
							If wichtel\geschenkmesh <> 0 Then score(2) = score(2) - 1
							If score(2) <=0 Then spielstatus = 3
							FreeEntity wichtel\geschenkmesh: wichtel\geschenkmesh = 0: deleteWichtel(wichtel\mesh) ; delete
							Exit
						EndIf
						
						wichtel\targetmesh = waypoint\mesh: Exit
					EndIf
				Next
			EndIf
			If wichtel <> Null And mesh = 0 Then
				PointEntity wichtel\mesh, wichtel\targetmesh
				MoveEntity wichtel\mesh, 0, 0, wichtelSpeed#
			EndIf
		EndIf
		skip = 0
	Next
	
	; Erzeuge neue Wichtel START
	If currwaypoints(1) < 2 Then Return -1 ; Keine Waypoints => keine Wichtel, 2 Da Waypointrun 1 schon fertig sein muss
	If MilliSecs() > memtimer + spawntimer Then
		Local spawnAt = Rnd(1, currwaypoints(1)-1) ; Den letzten WaypointRun nicht benutzen da dieser evtl. noch erstellt wird
		temp = newWichtel(spawnAt)
		For waypoint.Twaypoint = Each Twaypoint
			If waypoint\wpr = spawnAt Then Exit
		Next
		memtimer = MilliSecs()
		PositionEntity temp, waypoint\x#, 0, waypoint\z#
	EndIf
	; Erzeuge neue Wichtel END
End Function

;--------------------

Function deleteWichtel(mesh)
	For wichtel.Twichtel = Each Twichtel
		If wichtel\mesh = mesh Then
			If wichtel\geschenkmesh > 0 Then EntityParent wichtel\geschenkmesh, 0 ; Unparent damit es nicht mit dem Parent gelscht wird
			FreeEntity wichtel\mesh
			Delete wichtel
			Exit
		EndIf
	Next
End Function

;--------------------

Function newBullet(sx#,sy#,sz#,tx#,ty#,tz#,mesh = 0,art = 0)
	
	Bullet.TBullet = New TBullet
		Bullet\s#[1] = sx#
		Bullet\s#[2] = sy#
		Bullet\s#[3] = sz#
		Bullet\t#[1] = tx#
		Bullet\t#[2] = ty#
		Bullet\t#[3] = tz#
		
	Select art 
		Case 2: 	; Der Schuss ist ein Wichtel  --> Rcksto wenn Schlitten das Wichtel trifft
			Bullet\speed# = .5 ; anpassen an Animationsgeschwindigkeit
			Bullet\mesh = mesh
			Bullet\art = 2
			PositionEntity Bullet\mesh, Bullet\s#[1], Bullet\s#[2], Bullet\s#[3]
		Case 3: 	; Der Schuss ist ein Geschenk
			Bullet\speed# = .2 ; anpassen an Animationsgeschwindigkeit
			Bullet\mesh = mesh
			Bullet\art = 3
			PositionEntity Bullet\mesh, Bullet\s#[1], Bullet\s#[2], Bullet\s#[3]
		Default:	; Normaler Schuss
			Bullet\speed# = 1
			Bullet\mesh = CreateSphere(5): ScaleEntity Bullet\mesh, .3, .3, .3
			Bullet\art = 1
			PositionEntity Bullet\mesh, Bullet\s#[1], Bullet\s#[2], Bullet\s#[3]
			EntityType Bullet\mesh, 2
	End Select
	
End Function

;--------------------

Function updateBullet()
	Local tp = CreatePivot(), skip, collmesh
	For Bullet.TBullet = Each TBullet
		collmesh = EntityCollided(Bullet\mesh,1) ; Collision Ball <-> Wichtel
		If collmesh = 0 Then collmesh = EntityCollided(Bullet\mesh,4) ; Collision Ball <-> Objekt(Baum,Haus)
		
		If collmesh > 0 Then ; Es gab eine collision
			updateWichtel(collmesh,die) ; War das was mit dem Ball collidierte ein Wichtel? wenn Ja dann stirb
			FreeEntity Bullet\mesh: Delete Bullet
			Exit
		Else
			PositionEntity tp, Bullet\t#[1], 0, Bullet\t#[3]
			If EntityDistance (Bullet\mesh, tp) < 1 Then 
				Select Bullet\art
					Case 1:
						FreeEntity Bullet\mesh: Delete Bullet ; Ball lschen
					Case 2: ; Bullet ist Wichtel -> Mesh nicht lschen
						Delete Bullet 
					Case 3:
						FreeEntity Bullet\mesh: Delete Bullet ; Geschenk lschen
				End Select
				skip = 1
			EndIf
			
			If skip = 0 Then
				yaw_old = EntityYaw(Bullet\mesh)
				PointEntity Bullet\mesh, tp
				MoveEntity Bullet\mesh, 0, 0, Bullet\speed#
				If Bullet\art = 3 Then ; Geschenk
					RotateEntity Bullet\mesh, yaw_old+10, yaw_old+10, 0, 1 ; Drehung der Geschenke beim Rckflug
				Else
					RotateEntity Bullet\mesh, 0, yaw_old, 0, 1
				EndIf
			EndIf
		EndIf
	Next
	FreeEntity tp
End Function

;--------------------

Function gameINIT()
	
	Local ObjFile$ = "mapfile", i, n, file, WpFile$ = "wayfile", path$ = "data\"
	
	; Waypoints laden
	For waypoint.Twaypoint = Each Twaypoint
		FreeEntity waypoint\mesh
		Delete waypoint
	Next
	
	file = OpenFile(path$ + WpFile$)
	n = ReadInt(file) ; soviele Types folgen jetzt
	Local old_wpr
	currwaypoints(1) = 0: currwaypoints(2) = 0
	
	For i = 1 To n
		waypoint.Twaypoint = New Twaypoint
		waypoint\x = ReadInt(file)
		waypoint\z = ReadInt(file)
		waypoint\wpn = ReadInt(file)
		waypoint\wpr = ReadInt(file)
		temp = colored_wp(waypoint\wpr): ScaleEntity temp, .3, .3, .3
		PositionEntity temp, waypoint\x#, 1, waypoint\z#
		waypoint\mesh = temp: HideEntity temp
		
		If old_wpr <> waypoint\wpr Then ; neuer run
			currwaypoints(2) = 0 ;waypoints im run zurcksetzen
			currwaypoints(1) = currwaypoints(1) + 1 ; run inc
		Else
			currwaypoints(2) = currwaypoints(2) + 1 ; waypoint inc
		EndIf
		
		old_wpr = waypoint\wpr
	Next
	
	currwaypoints(2) = 0: currwaypoints(1) = currwaypoints(1) + 1 ; run inc
	CloseFile file: file = 0
	
	;Meshes laden
	For staticMesh.TstaticMesh = Each TstaticMesh
		FreeEntity staticMesh\mesh
		Delete staticMesh
	Next
	
	file = OpenFile(path$ + ObjFile$)
	n = ReadInt(file) ; soviele Types folgen jetzt
	
	For i = 1 To n
		staticMesh.TstaticMesh = New TstaticMesh
		staticMesh\x = ReadInt(file)
		staticMesh\z = ReadInt(file)
		staticMesh\objNum = ReadInt(file)
		staticMesh\yaw = ReadInt(file)
		temp = CopyEntity(staticObject(staticMesh\objNum))
		
		staticMesh\mesh = temp
		
		Select staticMesh\objNum
			Case 3:
				EntityTexture temp, present1_textures(Rnd(1,4))
			Case 4:
				EntityTexture temp, present2_textures(Rnd(1,4))
			Case 6:
				EntityTexture temp, wichtel_textures(Rnd(1,3))
			Case 9:
				weihnachtsbaum = temp
			Case 8:
				Animate temp, 2, .5, 1 ; Schneemann animieren
		End Select
		
		PositionEntity staticMesh\mesh, staticMesh\x, 0, staticMesh\z
		RotateEntity staticMesh\mesh, 0, staticMesh\yaw, 0
		If staticMesh\objNum = 6 Or staticMesh\objNum = 7 Then Animate temp, 2, 1, 1 ; lauf animation
	Next
	
	CloseFile file: file = 0
		
	
End Function

;--------------------

Function colored_wp(n)
	
	Local temp = CreateSphere(2)
	
	Select n
		Case 1: EntityColor temp, 10, 10, 10
		Case 2: EntityColor temp, 10, 10, 255
		Case 3: EntityColor temp, 10, 255, 10
		Case 4: EntityColor temp, 10, 255, 255
		Case 5: EntityColor temp, 255, 10, 10
		Case 6: EntityColor temp, 255, 10, 255
		Case 7: EntityColor temp, 255, 255, 10
		Case 8: EntityColor temp, 255, 255, 255
		Case 9: EntityColor temp, 100, 100, 100
		Default: EntityColor temp, 150, 10, 200
			
	End Select
	
	Return temp
	
End Function

;--------------------

Function newSound(titel$)
	Select titel$
		Case "hit":
			PlaySound (sounds(1))
		Case "die":
			PlaySound (sounds(2))
	End Select
End Function

;--------------------

Function LoadSprite2(spritepath$, mode=0, parent=0) ; normales Loadsprite klappt nicht gescheit btw. gibt MAV's
	
	If parent
		m = CreateMesh(parent)
	Else
		m = CreateMesh()
	EndIf
	
	;face
	If mode = 4 ; masked
		b=LoadBrush( spritepath$ ,32+16+4+1 )
	Else
		b=LoadBrush( spritepath$ ,32+16+1 )
	EndIf
	
	;face
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,0,0,0
	AddVertex s,-1,+1,0,1,0
	AddVertex s,-1,-1,0,1,1
	AddVertex s,+1,-1,0,0,1
	
	AddTriangle s,0,1,2
	AddTriangle s,0,2,3
	
	FreeBrush b
	
	;sprite.Tsprite = New Tsprite
	;sprite\mesh = m
	
	Return m
	
End Function

;--------------------

;~IDEal Editor Parameters:
;~C#Blitz3D
