Type TBaum
	Global _list:TList=CreateList()
	Global img_anhang:TImage[20]
	Global img_bg:TImage=LoadImage("gfx/baumbg.png")
	Global img_baum:TImage=LoadImage("gfx/baum.png")
	
	Field x:Float
	Field y:Float
	
	Field anhang:Int
	
	Function init()
		img_anhang[0]=LoadImage("gfx/geschenk1.png")
		img_anhang[1]=LoadImage("gfx/geschenk2.png")
		img_anhang[2]=LoadImage("gfx/kugeln_blau.png")
		img_anhang[3]=LoadImage("gfx/kugeln_gelb.png")
		img_anhang[4]=LoadImage("gfx/kugeln_gruen.png")
		img_anhang[5]=LoadImage("gfx/kugeln_rot.png")
		img_anhang[6]=LoadImage("gfx/schleifen.png")
		img_anhang[7]=LoadImage("gfx/stern.png")
		img_anhang[8]=LoadImage("gfx/zuckerstangen.png")
		img_anhang[9]=LoadImage("gfx/zweig.png")
		img_anhang[10]=LoadImage("gfx/glocken.png")
	End Function

	Method SetPos(_x:Int, _y:Int)
		x=_x
		y=_y
	End Method
End Type

Type TMyBaum Extends TBaum
	Field match_timer:Int
	
	Method Draw()
		SetScale .75,.75
		
		DrawImage img_baum,x,y
		
		If anhang&GESCHENK1 DrawImage img_anhang[0],x,y
		If anhang&GESCHENK2 DrawImage img_anhang[1],x,y
		If anhang&KUGELN_BLAU DrawImage img_anhang[2],x,y
		If anhang&KUGELN_GELB DrawImage img_anhang[3],x,y
		If anhang&KUGELN_GRUEN DrawImage img_anhang[4],x,y
		If anhang&KUGELN_ROT DrawImage img_anhang[5],x,y
		If anhang&SCHLEIFEN DrawImage img_anhang[6],x,y
		If anhang&STERN DrawImage img_anhang[7],x,y
		If anhang&ZUCKER DrawImage img_anhang[8],x,y
		If anhang&ZWEIG DrawImage img_anhang[9],x,y
		If anhang&GLOCKEN DrawImage img_anhang[10],x,y
		
		SetScale 1,1
	End Method
	
	Method Compete(baum:TModellBaum)
		If baum.anhang=anhang And match_timer=0 Then match_timer=MilliSecs()
	End Method
	
	Method Setup(mhit1:Int)
		If match_timer<>0 And MilliSecs()>match_timer+1000 anhang=0; baum=TModellBaum.CreateRandom(); match_timer=0
		If match_timer<>0 Return
		
		Local tmp_x:int
		Local tmp_y:int		
		
		tmp_x=10
		tmp_y=150
		DrawImage img_icon[0],tmp_x,tmp_y 'Geschenk1
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then 
			If mybaum.anhang&GESCHENK1
				mybaum.anhang:~GESCHENK1
			Else
				mybaum.anhang:|GESCHENK1
			End If
		End If
		
		tmp_x:+70
		DrawImage img_icon[1],tmp_x,tmp_y 'Geschenk2
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then 
			If mybaum.anhang&GESCHENK2
				mybaum.anhang:~GESCHENK2
			Else
				mybaum.anhang:|GESCHENK2
			End If
		End If
		
		tmp_x=10
		tmp_y:+70
		DrawImage img_icon[2],tmp_x,tmp_y 'Blau
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then  
			If mybaum.anhang&KUGELN_ROT mybaum.anhang:~KUGELN_ROT
			If mybaum.anhang&KUGELN_BLAU 
				mybaum.anhang:~KUGELN_BLAU
			Else
				mybaum.anhang:|KUGELN_BLAU
			End If
		End If
		
		tmp_x:+50
		DrawImage img_icon[5],tmp_x,tmp_y 'Rot
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then 
			If mybaum.anhang&KUGELN_BLAU mybaum.anhang:~KUGELN_BLAU
			If mybaum.anhang&KUGELN_ROT 
				mybaum.anhang:~KUGELN_ROT
			Else
				mybaum.anhang:|KUGELN_ROT
			End If
		End If

		
		tmp_x=10
		tmp_y:+70
		DrawImage img_icon[3],tmp_x,tmp_y 'Gelb
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then 
			If mybaum.anhang&KUGELN_GRUEN mybaum.anhang:~KUGELN_GRUEN
			If mybaum.anhang&KUGELN_GELB 
				mybaum.anhang:~KUGELN_GELB
			Else
				mybaum.anhang:|KUGELN_GELB
			End If
		End If
		
		tmp_x:+50
		DrawImage img_icon[4],tmp_x,tmp_y 'Grn
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then 
			If mybaum.anhang&KUGELN_GELB mybaum.anhang:~KUGELN_GELB
			If mybaum.anhang&KUGELN_GRUEN 
				mybaum.anhang:~KUGELN_GRUEN
			Else
				mybaum.anhang:|KUGELN_GRUEN
			End If
		End If
		
		tmp_x=10
		tmp_y:+70
		DrawImage img_icon[6],tmp_x,tmp_y 'Schleifen
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then  
			If mybaum.anhang&SCHLEIFEN
				mybaum.anhang:~SCHLEIFEN
			Else
				mybaum.anhang:|SCHLEIFEN
			End If
		End If
		
		tmp_x:+70
		DrawImage img_icon[7],tmp_x,tmp_y 'Stern
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then  
			If mybaum.anhang&STERN
				mybaum.anhang:~STERN
			Else
				mybaum.anhang:|STERN
			End If
		End If
		
		tmp_x=10
		tmp_y:+70
		DrawImage img_icon[8],tmp_x,tmp_y 'Zucker
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then 
			If mybaum.anhang&ZUCKER
				mybaum.anhang:~ZUCKER
			Else
				mybaum.anhang:|ZUCKER
			End If
		End If

		tmp_x:+70
		DrawImage img_icon[9],tmp_x,tmp_y 'Zweig
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then 
			If mybaum.anhang&ZWEIG
				mybaum.anhang:~ZWEIG
			Else
				mybaum.anhang:|ZWEIG
			End If
		End If

		tmp_x=10
		tmp_y:+70
		DrawImage img_icon[10],tmp_x,tmp_y 'Glocken
		If mhit1 And rectsoverlap(MouseX(),MouseY(),1,1, tmp_x,tmp_y,60,60) Then 
			If mybaum.anhang&GLOCKEN
				mybaum.anhang:~GLOCKEN
			Else
				mybaum.anhang:|GLOCKEN
			End If
		End If

	End Method
End Type

Type TModellBaum Extends TBaum
	Function CreateRandom:TModellBaum()
		Local inst:TModellBaum=New TModellBaum
		
		If Rand(0,4)=2 Then inst.anhang:|GESCHENK1
		If Rand(0,3)=2 Then inst.anhang:|GESCHENK2
		If Rand(0,2)=1 Then inst.anhang:|SCHLEIFEN
		If Rand(0,2)=1 Then inst.anhang:|STERN
		If Rand(0,1)=1 Then inst.anhang:|ZUCKER
		If Rand(0,5)=2 Then inst.anhang:|ZWEIG
		If Rand(0,10)=3 Then inst.anhang:|GLOCKEN
		
		Local random:Int=Rand(0,2)
		If random=1 inst.anhang:|KUGELN_BLAU
		If random=2 inst.anhang:|KUGELN_ROT
		
		random:Int=Rand(0,2)
		If random=1 inst.anhang:|KUGELN_GELB
		If random=2 inst.anhang:|KUGELN_GRUEN
		
		
		inst.SetPos(800,10)
		_list.addlast(inst)
		Return inst
	End Function
	
	Method Draw()
		If x>800-222 Then x=x-((x-(800-222))/10)
		
		SetScale .5,.5
		
		SetAlpha 0.5
		DrawImage img_bg,x,y
		SetAlpha 1
		
		DrawImage img_baum,x,y
		
		If anhang&GESCHENK1 DrawImage img_anhang[0],x,y
		If anhang&GESCHENK2 DrawImage img_anhang[1],x,y
		If anhang&KUGELN_BLAU DrawImage img_anhang[2],x,y
		If anhang&KUGELN_GELB DrawImage img_anhang[3],x,y
		If anhang&KUGELN_GRUEN DrawImage img_anhang[4],x,y
		If anhang&KUGELN_ROT DrawImage img_anhang[5],x,y
		If anhang&SCHLEIFEN DrawImage img_anhang[6],x,y
		If anhang&STERN DrawImage img_anhang[7],x,y
		If anhang&ZUCKER DrawImage img_anhang[8],x,y
		If anhang&ZWEIG DrawImage img_anhang[9],x,y
		If anhang&GLOCKEN DrawImage img_anhang[10],x,y
		
		SetScale 1,1
	End Method
End Type
	