AppTitle "Schneeengel"
Graphics 640,480,8,2
SetBuffer BackBuffer()
timer = CreateTimer(60)
TFormFilter 0
SeedRnd MilliSecs()

;Laden - Bilder
Global ld = LoadImage(".\gfx\ld.png")
Global lb = LoadImage(".\gfx\lb.png")
Global process#
MaskImage lb,255,0,255
Global go = LoadImage(".\gfx\go.png")
Global chn
Global musik = LoadSound(".\bells.mp3")
LoopSound(musik)
chn = PlaySound(musik)
load()
Global hs = LoadImage(".\gfx\hs.png")
Global menu = LoadAnimImage(".\gfx\menu.png",200,300,0,3)
MaskImage menu,255,0,255
Global bg = LoadImage(".\gfx\bg.png")
Global fg = LoadImage(".\gfx\fg.png")
MaskImage fg,255,0,255
Global sb = LoadImage(".\gfx\sb.png")
MaskImage sb,255,0,255
Global mte = LoadImage(".\gfx\mte.png")
Global dis = LoadImage(".\gfx\dis.png")
load()
Global schl = LoadImage(".\gfx\schssel.png")
MaskImage schl,255,0,255
MidHandle schl
Global engel = LoadImage(".\gfx\engel.png")
MaskImage engel,255,0,255
MidHandle engel
Global fluegel = LoadAnimImage(".\gfx\flgel.png",100,100,0,4)
MaskImage fluegel,255,0,255
MidHandle fluegel
load()
Dim flocken_k(17)
Dim flocken_m(17)
Dim flocken_g(17)
load()
For i = 0 To 17
	flocken_k(i) = LoadAnimImage(".\gfx\flocken.png",32,32,0,3)
	MaskImage flocken_k(i),255,0,255
	ScaleImage flocken_k(i),0.5,0.5
	MidHandle flocken_k(i)
	RotateImage flocken_k(i),i*5
	flocken_m(i) = LoadAnimImage(".\gfx\flocken.png",32,32,0,3)
	MaskImage flocken_m(i),255,0,255
	MidHandle flocken_m(i)
	RotateImage flocken_m(i),i*5
	flocken_g(i) = LoadAnimImage(".\gfx\flocken.png",32,32,0,3)
	MaskImage flocken_g(i),255,0,255
	ScaleImage flocken_g(i),2,2
	MidHandle flocken_g(i)
	RotateImage flocken_g(i),i*5
	load()
Next
Global typ = LoadAnimImage(".\gfx\typ.png",175,100,0,4)
MaskImage typ,255,0,255
Global schnee = LoadAnimImage(".\gfx\schnee.png",175,100,0,4)
MaskImage schnee,255,0,255
load()

;Variablen laden
Global frost,reg,reg_t,sog_t,slow_t,snow_t
Global x=200,y=200,frame
Global lvl=1
Global score,magic,mute,menustatus,ende=False,play=False
Dim rank(10)
Dim name$(10)
load()

;Types
Type flocke
	Field angle
	Field x,y
	Field look
	Field size
	Field dir
End Type
load()



;Spiel
Repeat ;Haupschleife
	FlushKeys()
	Repeat ;Menueschleife
		play = False
		If KeyHit(200) Then
			menustatus = menustatus - 1
			If menustatus < 0 Then menustatus = 0
		ElseIf KeyHit(208) Then
			menustatus = menustatus + 1
			If menustatus > 2 Then menustatus = 2
		EndIf
		Cls
		DrawImage hs,0,0
		DrawImage menu,220,50,menustatus
		If KeyHit(1) Then ende= True
		Flip
	Until KeyHit(28) Or ende=True
	If ende = False Then ;Menueasuwertung
		Select menustatus
		Case 0
			play=True
		Case 1
			FlushKeys()
			Cls
			DrawImage hs,0,0
			highscoreshow()
			Flip
			WaitKey()
		Case 2
			ende= True
		End Select
	EndIf
	If play=True Then ;Spielschleife
		While (Not frost>=100 Or ende=True)
			Cls
			schneien()
			control()
			upgrades()
			draw()
			WaitTimer(timer)
			If KeyHit(1) Then ende=True
			Flip
		Wend
		FlushKeys()
		Cls
		DrawImage go,0,0
		highscoreing()
		Flip
		WaitKey()
		reset()
	EndIf
Until ende = True
End


Function control()
	;Engelkontrolle
	If KeyDown(200) Then
		y=y-3
	ElseIf KeyDown(208) Then
		y=y+3
	EndIf
	If KeyDown(203) Then
		x=x-3
	ElseIf KeyDown(205) Then
		x=x+3
	EndIf
	If x < 32 Then
		x=32
	ElseIf x > 468 Then
		x=468
	EndIf
	If y < 100 Then
		y=100
	ElseIf y > 300 Then
		y=300
	EndIf
	;Framevernderung
	frame = frame+1
	If frame = 80 Then frame = 0
	;Regeneration
	reg_t=reg_t+(1*reg)
	If reg_t >= 120 Then
		frost = frost - 1
		If frost < 0 Then frost = 0
		reg_t = 0
	EndIf
	;Sontige Timer
	sog_t = sog_t - 1
	If sog_t < 0 Then sog_t = 0
	slow_t = slow_t - 1
	If slow_t < 0 Then slow_t = 0
	snow_t = snow_t - 1
	If snow_t < 0 Then level()
End Function

Function letitsnow() ;Schnee spawnen
	f.flocke = New flocke
	f\size = Rand(0,2)
	f\x = Rand(8*(2^f\size),500-(8*(2^f\size)))
	f\angle = Rand(0,89)
	Repeat
		f\dir = Rand(-1,1)
	Until f\dir<>0
	f\y=0
	f\look = Rand(0,2)
End Function

Function schneien()
	For f.flocke = Each flocke
		;Abrtsbewegung
		If slow_t <= 0 Then f\y = f\y + lvl
		If f\y > 400 Then
			frost = frost + 1 + f\size
			Delete f.flocke
			Exit
		EndIf
		;Einsaugen
		If sog_t > 0 Then
			If f\x > x Then
				f\x = f\x-1
			ElseIf f\x < x Then
				f\x = f\x+1
			EndIf
		EndIf
		;Drehen
		f\angle = f\angle + f\dir
		f\angle = (f\angle+89) Mod 89
		;Kollision
		Select f\size
		Case 0
			If ImagesCollide(flocken_k(f\angle/5),f\x,f\y,f\look,schl,x,y,0) Then
				Delete f.flocke
				score=score+1
				magic=magic+1
				If magic > 100 Then magic = 100
			EndIf
		Case 1
			If ImagesCollide(flocken_m(f\angle/5),f\x,f\y,f\look,schl,x,y,0) Then
				Delete f.flocke
				score=score+1
				magic=magic+1
				If magic > 100 Then magic = 100
			EndIf
		Case 2
			If ImagesCollide(flocken_g(f\angle/5),f\x,f\y,f\look,schl,x,y,0) Then
				Delete f.flocke
				score=score+1
				magic=magic+1
				If magic > 100 Then magic = 100
			EndIf
		End Select
	Next
End Function

Function upgrades()
	If KeyHit(2) Then ;Glhwein
		If magic >= 20 Then
			magic = magic - 20
			frost = frost - 20
		EndIf
	ElseIf KeyHit(3) Then ;Sog
		If magic >= 40 Then
			magic = magic - 40
			sog_t = 150
		EndIf
	ElseIf KeyHit(4) Then ;Slow
		If magic >= 80 Then
			magic = magic - 80
			slow_t = 300
		EndIf
	ElseIf KeyHit(5) Then ;Regeneration
		If magic = 100 And reg < 3 Then
			reg = reg + 1
			magic = magic - 100
		EndIf
	ElseIf KeyHit(6) Then ;Mute
		If mute = True Then
			ChannelVolume chn,1
			mute = False
		Else
			ChannelVolume chn,0
			mute = True
		EndIf
	EndIf
End Function

Function level()
	For f.flocke = Each flocke
		anzahl = anzahl + 1
	Next
	If score < 1000 Then
		lvl=1
		If anzahl < 1 + (score/10) Then letitsnow()
		Select score/100
		Case 0
			snow_t = Rand(20,60)
		Case 1
			snow_t = Rand(15,50)
		Case 2
			snow_t = Rand(10,40)
		Case 3
			snow_t = Rand(10,30)
		Case 4
			snow_t = Rand(10,20)
		Default
			snow_t = 10
		End Select
	ElseIf score < 2000 Then
		lvl=2
		If anzahl < 1 + ((score-1000)/10) Then letitsnow()
		Select (score-1000)/100
		Case 0
			snow_t = Rand(20,60)
		Case 1
			snow_t = Rand(15,50)
		Case 2
			snow_t = Rand(10,40)
		Case 3
			snow_t = Rand(10,30)
		Case 4
			snow_t = Rand(10,20)
		Default
			snow_t = 10
		End Select
	Else
		lvl=3
		If anzahl < 1 + ((score-2000)/10) Then letitsnow()
		Select (score-2000)/100
		Case 0
			snow_t = Rand(20,60)
		Case 1
			snow_t = Rand(15,50)
		Case 2
			snow_t = Rand(10,40)
		Case 3
			snow_t = Rand(10,30)
		Case 4
			snow_t = Rand(10,20)
		Default
			snow_t = 10
		End Select
	EndIf
End Function

Function draw()
	DrawImage bg,0,0
	DrawImage fg,0,0
	Color 255,0,0
	Rect 500,0,140,300
	Color 0,0,255
	Rect 500,0,140,3*frost
	Color 255,255,0
	Rect 500,300,magic*1.4,180
	Color 255,255,255
	DrawImage sb,500,0
	If mute = False Then DrawImage mte,609,330
	If reg = 3 Then DrawImage dis,584,314
	DrawImage typ,135,355,reg
	If frost < 40 And frost >= 20 Then
		DrawImage schnee,135,355,0
	ElseIf frost < 60 And frost >= 20 Then
		DrawImage schnee,135,355,1
	ElseIf frost < 80 And frost >= 20 Then
		DrawImage schnee,135,355,2
	ElseIf frost < 100 And frost >= 20 Then
		DrawImage schnee,135,355,3
	EndIf
	For f.flocke = Each flocke
		Select f\size
		Case 0
			DrawImage flocken_k(f\angle/5),f\x,f\y,f\look
		Case 1
			DrawImage flocken_m(f\angle/5),f\x,f\y,f\look
		Case 2
			DrawImage flocken_g(f\angle/5 ),f\x,f\y,f\look
		End Select
	Next
	DrawImage schl,x,y
	DrawImage engel,x,y
	If frame < 20 Then
		DrawImage fluegel,x,y,0
	ElseIf frame < 40 Then
		DrawImage fluegel,x,y,1
	ElseIf frame < 60 Then
		DrawImage fluegel,x,y,2
	Else
		DrawImage fluegel,x,y,3
	EndIf
	strg$ = score
	Text 520,276,"Score: "
	Text 520,290,String("0",4-Len(strg$))+score
	Text 570,415,magic+"/100",1,1
	Text 615,275,(100-frost),1,1
	Text 599,226,20
	Text 599,166,40
	Text 599,106,60
	Text 599,46,80
End Function

Function load() ;Loadingbar anzeigen
	Cls
	process = process + 4
	If process > 100 Then process=100
	DrawImage ld,0,0
	DrawImageRect lb,30,375,0,0,process*5.8,105
	Flip
End Function

Function highscoreing() ;Highscore positionieren
	ranking=OpenFile(".\highscore.dat")
	rank(0)=score
	For i = 1 To 10
		name$(i)=ReadLine(ranking)
		rank(i)=ReadLine(ranking)
	Next
	FlushKeys()
	If rank(0)>rank(1) Then ;Platz 1
		rank(10)=rank(9)
		rank(9)=rank(8)
		rank(8)=rank(7)
		rank(7)=rank(6)
		rank(6)=rank(5)
		rank(5)=rank(4)
		rank(4)=rank(3)
		rank(3)=rank(2)
		rank(2)=rank(1)
		rank(1)=rank(0)
		name(10)=name(9)
		name(9)=name(8)
		name(8)=name(7)
		name(7)=name(6)
		name(6)=name(5)
		name(5)=name(4)
		name(4)=name(3)
		name(3)=name(2)
		name(2)=name(1)
		Locate 250,260
		name(1)=Input("Gib deinen Namen ein:")
	ElseIf rank(0)>rank(2) Then ;Platz 2
		rank(10)=rank(9)
		rank(9)=rank(8)
		rank(8)=rank(7)
		rank(7)=rank(6)
		rank(6)=rank(5)
		rank(5)=rank(4)
		rank(4)=rank(3)
		rank(3)=rank(2)
		rank(2)=rank(0)
		name(10)=name(9)
		name(9)=name(8)
		name(8)=name(7)
		name(7)=name(6)
		name(6)=name(5)
		name(5)=name(4)
		name(4)=name(3)
		name(3)=name(2)
		Locate 250,260
		name(2)=Input("Gib deinen Namen ein:")
	ElseIf rank(0)>rank(3) Then ;Platz 3
		rank(10)=rank(9)
		rank(9)=rank(8)
		rank(8)=rank(7)
		rank(7)=rank(6)
		rank(6)=rank(5)
		rank(5)=rank(4)
		rank(4)=rank(3)
		rank(3)=rank(0)
		name(10)=name(9)
		name(9)=name(8)
		name(8)=name(7)
		name(7)=name(6)
		name(6)=name(5)
		name(5)=name(4)
		name(4)=name(3)
		Locate 250,260
		name(3)=Input("Gib deinen Namen ein:")
	ElseIf rank(0)>rank(4) Then  ;Platz 4
		rank(10)=rank(9)
		rank(9)=rank(8)
		rank(8)=rank(7)
		rank(7)=rank(6)
		rank(6)=rank(5)
		rank(5)=rank(4)
		rank(4)=rank(0)
		name(10)=name(9)
		name(9)=name(8)
		name(8)=name(7)
		name(7)=name(6)
		name(6)=name(5)
		name(5)=name(4)
		Locate 250,260
		name(4)=Input("Gib deinen Namen ein:")
	ElseIf rank(0)>rank(5) Then ;Platz 5
		rank(10)=rank(9)
		rank(9)=rank(8)
		rank(8)=rank(7)
		rank(7)=rank(6)
		rank(6)=rank(5)
		rank(5)=rank(0)
		name(10)=name(9)
		name(9)=name(8)
		name(8)=name(7)
		name(7)=name(6)
		name(6)=name(5)
		Locate 250,260
		name(5)=Input("Gib deinen Namen ein:")
	ElseIf rank(0)>rank(6) Then ;Platz 6
		rank(10)=rank(9)
		rank(9)=rank(8)
		rank(8)=rank(7)
		rank(7)=rank(6)
		rank(6)=rank(0)
		name(10)=name(9)
		name(9)=name(8)
		name(8)=name(7)
		name(7)=name(6)
		Locate 250,260
		name(6)=Input("Gib deinen Namen ein:")
	ElseIf rank(0)>rank(7) Then ;Platz 7
		rank(10)=rank(9)
		rank(9)=rank(8)
		rank(8)=rank(7)
		rank(7)=rank(0)
		name(10)=name(9)
		name(9)=name(8)
		name(8)=name(7)
		Locate 250,260
		name(7)=Input("Gib deinen Namen ein:")
	ElseIf rank(0)>rank(8) Then ;Platz 8
		rank(10)=rank(9)
		rank(9)=rank(8)
		rank(8)=rank(0)
		name(10)=name(9)
		name(9)=name(8)
		Locate 250,260
		name(8)=Input("Gib deinen Namen ein:")
	ElseIf rank(0)>rank(9) Then ;Platz 9
		rank(10)=rank(9)
		rank(9)=rank(0)
		name(10)=name(9)
		Locate 250,260
		name(9)=Input("Gib deinen Namen ein:")
	ElseIf rank(0)>rank(10) Then ;Platz 10
		rank(10)=rank(0)
		Locate 250,260
		name(10)=Input("Gib deinen Namen ein:")
	EndIf
	CloseFile(ranking)
	ranking=WriteFile(".\highscore.dat")
	For i = 1 To 10 ;Highscore anzeigen und schreiben
		Text 390,274+(14*(i-1)),i+"."
		WriteLine ranking,name(i)
		Text 412,274+(14*(i-1)),name(i)
		WriteLine ranking,rank(i)
		Text 580,274+(14*(i-1)),rank(i)
	Next
	CloseFile(ranking)
End Function

Function highscoreshow() ;Highscore nur anzeigen
	ranking=ReadFile(".\highscore.dat")
	For i = 1 To 10
		name$(i)=ReadLine(ranking)
		rank(i)=ReadLine(ranking)
	Next
	For i = 1 To 10
		Text 198,100+(14*(i-1)),i+"."
		Text 220,100+(14*(i-1)),name(i)
		Text 388,100+(14*(i-1)),rank(i)
	Next
	CloseFile(ranking)
End Function

Function reset() ;Resetten der Variablen
	frost=0
	reg=0
	reg_t=0
	sog_t=0
	slow_t=0
	snow_t=0
	x=200
	y=200
	score=0
	magic=0
	For f.flocke = Each flocke
		Delete f.flocke
	Next
End Function